DECLARE SUB Playwav (Tmp1!, Tmp1$)
DECLARE SUB DMAPlay (Segment&, Offset&, Length&)
DECLARE SUB GetBlaster ()
DECLARE SUB AdjustVolume (Loudness%)
DECLARE SUB ResetDSP (Var!)
DECLARE SUB WriteDSP (byte2%)
REM File: Playwav.bas - for Dndbbs modules.

COMMON SHARED Baseport%
COMMON SHARED Channel%

REM Plays .wav files for blind or sight impaired people.

REM This code was adapted from Dma.zip written by Mike Huff (1996).
REM Which was modified by Martin Rampersad. Thanks guys! ejo-)

REM Program downloaded from http://www.ocf.berkeley.edu/~horie

IF COMMAND$ <> "" THEN
   IF COMMAND$ = "/?" THEN
      COLOR 15
      PRINT "Playtest .wav file tester:"
      COLOR 14
      PRINT "  Command line [<ALL>][<filename.wav>]"
      PRINT "    ALL - loop through all .wav files."
      PRINT "    <filename.wav> play specific .wav file."
      PRINT "       defaults to play internal .wav files."
      END
   END IF
   IF COMMAND$ = "ALL" THEN
      CLS
      X$ = DIR$("*.WAV")
      IF LEN(X$) THEN
         DO
            CALL Playwav(V, X$)
            X = X + 1
            SLEEP 3
            X$ = DIR$
            IF X$ = "" THEN
               EXIT DO
            END IF
         LOOP
      END IF
      PRINT X; "files."
   ELSE
      IF DIR$(COMMAND$) <> "" THEN
         CALL Playwav(V, COMMAND$)
      END IF
   END IF
ELSE
   FOR V = 1 TO 12
      CALL Playwav(V, "")
      SLEEP 1
   NEXT
END IF
END

' Turn on speaker and adjust volume.
SUB AdjustVolume (Loudness%)
 ON LOCAL ERROR GOTO Play.Error4
 ' Turn on speaker.
 V% = &HD1
 CALL WriteDSP(V%)
 ' Adjust the volume.
 V% = Loudness% + Loudness% * 16 ' right/left
 OUT Baseport% + 4, &H22
 OUT Baseport% + 5, V% AND &HFF
Play.Resume4:
 EXIT SUB
Play.Error4:
 RESUME Play.Resume4
END SUB

' Transfers and plays the contents of the buffer.
SUB DMAPlay (Segment&, Offset&, Length&)
 ON LOCAL ERROR GOTO Play.Error2
 Freq& = 10000
 Length& = Length& - 1
 Page% = 0
 MemLoc& = Segment& * 16 + Offset&
 SELECT CASE Channel%
 CASE 0
    PgPort% = &H87
    AddPort% = &H0
    LenPort% = &H1
    ModeReg% = &H48
 CASE 1
    PgPort% = &H83
    AddPort% = &H2
    LenPort% = &H3
    ModeReg% = &H49
 CASE 2
    PgPort% = &H81
    AddPort% = &H4
    LenPort% = &H5
    ModeReg% = &H4A
 CASE 3
    PgPort% = &H82
    AddPort% = &H6
    LenPort% = &H7
    ModeReg% = &H4B
 CASE ELSE
    EXIT SUB
 END SELECT
 OUT &HA, &H4 + Channel%
 OUT &HC, &H0
 OUT &HB, ModeReg%
 OUT AddPort%, MemLoc& AND &HFF
 OUT AddPort%, (MemLoc& AND &HFFFF&) \ &H100
 IF MemLoc& AND 65536 THEN
    Page% = Page% + 1
 END IF
 IF MemLoc& AND 131072 THEN
    Page% = Page% + 2
 END IF
 IF MemLoc& AND 262144 THEN
    Page% = Page% + 4
 END IF
 IF MemLoc& AND 524288 THEN
    Page% = Page% + 8
 END IF
 OUT PgPort%, Page%
 OUT LenPort%, Length& AND &HFF
 OUT LenPort%, (Length& AND &HFFFF&) \ &H100
 OUT &HA, Channel%

 TimeConst% = 256 - 1000000 \ Freq&
 V% = &H40
 CALL WriteDSP(V%)

 V% = TimeConst%
 CALL WriteDSP(V%)

 V% = &H14
 CALL WriteDSP(V%)

 V% = CINT(Length& AND &HFF)
 CALL WriteDSP(V%)

 V% = CINT((Length& AND &HFFFF&) \ &H100)
 CALL WriteDSP(V%)
Play.Resume2:
 EXIT SUB
Play.Error2:
 RESUME Play.Resume2
END SUB

' parse the BLASTER environment string and return settings.
SUB GetBlaster
 ON LOCAL ERROR GOTO Play.Error3
 REM SET BLASTER=A220 I5 D1 H5 P330 T3
 Var$ = ENVIRON$("BLASTER")
 IF Var$ = "" THEN ' default values
    Baseport% = &H220
    Channel% = &H1
    EXIT SUB
 END IF
 Var% = INSTR(Var$, "A") ' base IO port
 IF Var% THEN ' A220
    Baseport% = VAL("&H" + MID$(Var$, Var% + 1, 3))
 END IF
 Var% = INSTR(Var$, "D") ' 8-bit DMA channel
 IF Var% THEN ' D1
    Channel% = VAL(MID$(Var$, Var% + 1, 1))
 END IF
Play.Resume3:
 EXIT SUB
Play.Error3:
 RESUME Play.Resume3
END SUB

SUB Playwav (Tmp1, Tmp1$)
 ON LOCAL ERROR GOTO Play.Error
 CONST PlayBuffer = 32767
 DIM WavBuffer(1) AS STRING * PlayBuffer

 ' get playwav config variables
 Option1 = -1
 Option2% = 13

 IF Tmp1$ = "" THEN
 ' select .wav file
 Tmp1$ = ""
 SELECT CASE Tmp1
 CASE 1
    Tmp1$ = "LASER.WAV"
 CASE 2
    Tmp1$ = "RINGIN.WAV"
 CASE 3
    Tmp1$ = "CARRIER.WAV"
 CASE 4
    Tmp1$ = "BOING.WAV"
 CASE 5
    Tmp1$ = "BANG.WAV"
 CASE 6
    Tmp1$ = "CONNECT.WAV"
 CASE 7
    Tmp1$ = "COMPLETE.WAV"
 CASE 8
    Tmp1$ = "GUNSHOT.WAV"
 CASE 9
    Tmp1$ = "RICOCHET.WAV"
 CASE 10 ' a
    Tmp1$ = "WHOOSH.WAV"
 CASE 11 ' b
    Tmp1$ = "GLASS.WAV"
 CASE 12 ' c
    Tmp1$ = "CASHREG.WAV"
 CASE ELSE
    EXIT SUB
 END SELECT
 END IF

 ' locate file
 IF Tmp1$ = "" THEN
    EXIT SUB
 END IF
 Tmp1$=UCASE$(Tmp1$)
 IF RIGHT$(Tmp1$,4)<>".WAV" THEN
    EXIT SUB
 END IF
 Tmp2$ = Tmp1$

 ' Parse BLASTER environment variable
 CALL GetBlaster
 COLOR 15, 0
 PRINT "Baseport="; Baseport%
 IF Baseport% = 0 THEN
    EXIT SUB
 END IF
 PRINT "Channel="; Channel%

 ' Reset DSP (digital signal processor)
 FOR Tmp2 = 1 TO 3
    CALL ResetDSP(Var)
    IF Var THEN
       EXIT FOR
    END IF
 NEXT
 IF Var = 0 THEN
    PRINT "Reset DSP failed."
    EXIT SUB
 END IF
 COLOR 14, 0
 PRINT Tmp2$

 ' open input file
 CLOSE #1
 OPEN Tmp2$ FOR BINARY AS #1

 ' check wave format
 IF LOF(1) < 44 THEN
    PRINT "Length=0"
    EXIT SUB
 END IF

 ' create buffer for file.
 PlayBuffer2 = LOF(1)

 ' turn on speaker and adjust volume.
 CALL AdjustVolume(Option2%)

 ' Display length.
 Length& = LOF(1) - 44
 PRINT "Length="; Length&

 ' Get buffer from file (skip header on WAV)
 Length& = PlayBuffer2
 GET #1, 44, WavBuffer(1)

 ' Store memory address of sound buffer.
 Segment& = VARSEG(WavBuffer(1))
 Offset& = VARPTR(WavBuffer(1))
 CALL DMAPlay(Segment&, Offset&, Length&)
Play.Resume:
 EXIT SUB
Play.Error:
 PRINT "Error:";ERR
 RESUME Play.Resume
END SUB

' Resets the DSP (digital signal processor)
SUB ResetDSP (Var)
 ON LOCAL ERROR GOTO Play.Error5
 Var = 0
 OUT Baseport% + 6, 1
 FOR CountX% = 1 TO 4
    Eat% = INP(Baseport% + 6)
 NEXT
 OUT Baseport% + 6, 0
 IF INP(Baseport% + 14) AND &H80 = &H80 THEN
    IF INP(Baseport% + 10) = &HAA THEN
       Var = -1
    END IF
 END IF
Play.Resume5:
 EXIT SUB
Play.Error5:
 RESUME Play.Resume5
END SUB

' Writes a byte to the DSP (digital signal processor)
SUB WriteDSP (byte2%)
 ON LOCAL ERROR GOTO Play.Error7
 DO: LOOP WHILE INP(Baseport% + 12) AND &H80
 OUT Baseport% + 12, byte2%
Play.Resume7:
 EXIT SUB
Play.Error7:
 RESUME Play.Resume7
END SUB

